Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 568480 - app-portage/gentoolkit-0.3.1: revdep-rebuild gives different result than revdep-rebuild.sh
Summary: app-portage/gentoolkit-0.3.1: revdep-rebuild gives different result than revd...
Status: CONFIRMED
Alias: None
Product: Portage Development
Classification: Unclassified
Component: Tools (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Portage Tools Team
URL:
Whiteboard:
Keywords:
: 571242 573054 (view as bug list)
Depends on:
Blocks:
 
Reported: 2015-12-16 21:33 UTC by Nikos Chantziaras
Modified: 2018-02-23 14:04 UTC (History)
11 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
broken host-woods.gz (host-woods.gz,77.92 KB, application/octet-stream)
2016-01-06 15:36 UTC, Alex Busenius
Details
revdep-rebuild vs revdep-rebuild.sh (revdep-rebuild-diff.log,6.21 KB, text/plain)
2016-03-02 01:34 UTC, Thomas Deutschmann
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Nikos Chantziaras 2015-12-16 21:33:51 UTC
New Python-based revdep-rebuild:

======================
revdep-rebuild -i -- -a    
 * This is the new python coded version
 * Please report any bugs found using it.
 * The original revdep-rebuild script is installed as revdep-rebuild.sh
 * Please files bugs at: https://bugs.gentoo.org/
 * Collecting system binaries and libraries
 * Checking dynamic linking consistency
 * Assign files to packages

Your system is consistent
======================


Old revdep-rebuild.sh:


======================
revdep-rebuild.sh -i -- -a
 * Configuring search environment for revdep-rebuild

 * Checking reverse dependencies
 * Packages containing binaries and libraries broken by a package update
 * will be emerged.

 * Collecting system binaries and libraries
 * Generated new 1_files.rr
 * Collecting complete LD_LIBRARY_PATH
 * Generated new 2_ldpath.rr
 * Checking dynamic linking consistency
[ 9% ]  *   broken /usr/bin/host-woods (symbol h_errno, version GLIBC_PRIVATE not defined in file libc.so.6 with link time reference)
[ 100% ]                 
 * Generated new 3_broken.rr
 * Assigning files to packages
 *   /usr/bin/host-woods -> net-dns/host
 * Generated new 4_raw.rr and 4_owners.rr
 * Cleaning list of packages to rebuild
 * Generated new 4_pkgs.rr
 * Assigning packages to ebuilds
 * Generated new 4_ebuilds.rr
 * Evaluating package order
 * Generated new 5_order.rr
 * All prepared. Starting rebuild
emerge --complete-graph=y --oneshot --quiet-build=n --backtrack=30 -a net-dns/host:0
..........

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild   R    ] net-dns/host-20070128-r1 

Would you like to merge these packages? [Yes/No]
Comment 1 Nikos Chantziaras 2015-12-16 21:36:02 UTC
$ emerge --info app-portage/gentoolkit
Portage 2.2.26 (python 3.4.3-final-0, default/linux/amd64/13.0/desktop/plasma, gcc-4.9.3, glibc-2.22-r1, 4.1.14-gentoo x86_64)
=================================================================
                         System Settings
=================================================================
System uname: Linux-4.1.14-gentoo-x86_64-Intel-R-_Core-TM-_i5-2500K_CPU_@_3.30GHz-with-gentoo-2.2
KiB Mem:    16385312 total,   8694512 free
KiB Swap:   25166912 total,  25166912 free
Timestamp of repository gentoo: Wed, 16 Dec 2015 19:15:01 +0000
sh bash 4.3_p42
ld GNU ld (Gentoo 2.25.1 p1.1) 2.25.1
app-shells/bash:          4.3_p42::gentoo
dev-lang/perl:            5.22.0::gentoo
dev-lang/python:          2.7.11::gentoo, 3.3.5-r5::gentoo, 3.4.3-r5::gentoo
dev-util/cmake:           3.4.1::gentoo
dev-util/pkgconfig:       0.29::gentoo
sys-apps/baselayout:      2.2::gentoo
sys-apps/openrc:          0.19.1::gentoo
sys-apps/sandbox:         2.9::gentoo
sys-devel/autoconf:       2.13::gentoo, 2.69-r1::gentoo
sys-devel/automake:       1.11.6-r1::gentoo, 1.14.1::gentoo, 1.15::gentoo
sys-devel/binutils:       2.25.1-r1::gentoo
sys-devel/gcc:            4.9.3::gentoo
sys-devel/gcc-config:     1.8::gentoo
sys-devel/libtool:        2.4.6-r1::gentoo
sys-devel/make:           4.1-r1::gentoo
sys-kernel/linux-headers: 4.1::gentoo (virtual/os-headers)
sys-libs/glibc:           2.22-r1::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: rsync
    sync-uri: rsync://rsync.europe.gentoo.org/gentoo-portage
    priority: -1000

interactive-fiction
    location: /var/lib/layman/interactive-fiction
    sync-type: laymansync
    sync-uri: git://repo.or.cz/gentoo-interactive-fiction.git
    masters: gentoo
    priority: 50

steam-overlay
    location: /var/lib/layman/steam-overlay
    sync-type: laymansync
    sync-uri: git://github.com/anyc/steam-overlay.git
    masters: gentoo
    priority: 50

vmware
    location: /var/lib/layman/vmware
    sync-type: laymansync
    sync-uri: git://anongit.gentoo.org/proj/vmware.git
    masters: gentoo
    priority: 50

Local
    location: /usr/local/portage
    masters: gentoo
    priority: 99999999

ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-pipe -mtune=native -march=native -O2 -fomit-frame-pointer -floop-interchange -floop-strip-mine -floop-block"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/config /usr/share/gnupg/qualified.txt /usr/share/themes/oxygen-gtk/gtk-2.0 /usr/share/themes/oxygen-gtk/gtk-3.0"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/splash /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-pipe -mtune=native -march=native -O2 -fomit-frame-pointer -floop-interchange -floop-strip-mine -floop-block"
DISTDIR="/mnt/Data/portage/distfiles"
EMERGE_DEFAULT_OPTS="--quiet-build=n --backtrack=30"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs config-protect-if-modified distlocks ebuild-locks fixlafiles merge-sync metadata-transfer news parallel-fetch preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://ftp.ntua.gr/pub/linux/gentoo http://mirror.ovh.net/gentoo-distfiles http://distfiles.gentoo.org"
LANG="en_US.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed -Wl,--hash-style=gnu -Wl,--sort-common"
MAKEOPTS="-j4"
PKGDIR="/mnt/Data/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
USE="X a52 aac acl acpi aes aes-ni alsa amd64 audiofile avx bash-completion branding bzip2 cairo cdr cli consolekit cracklib crypt cxx dbus declarative dri dts dvd dvdr emboss encode exif fam fbcondecor flac gdbm gif glamor gpm gtk iconv ipv6 jpeg kde kipi lcdfilter lcms libnotify libsamplerate lm_sensors mad mmx mmxext mng modules mp3 mp4 mpeg multilib ncurses nptl nvidia offensive ogg opengl openmp pam pango pcre pdf pgo phonon plasma png policykit popcnt ppds pulseaudio qml qt4 qt5 readline seccomp session spell sse sse2 sse3 sse4 sse4_1 sse4_2 ssl ssse3 startup-notification svg tcpd tiff truetype udev udisks unicode upower usb vdpau vorbis widgets wxwidgets x264 xattr xcb xcomposite xml xv xvid xvmc zlib" ABI_X86="64 32" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" CAMERAS="ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="aes aes-ni avx mmx mmxext popcnt sse sse2 sse3 sse4 sse4_1 sse4_2 ssse3" DRACUT_MODULES="plymouth" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ublox ubx" GRUB_PLATFORMS="emu efi-32 efi-64 pc" INPUT_DEVICES="evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="en en_US" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-5" PYTHON_SINGLE_TARGET="python2_7" PYTHON_TARGETS="python2_7 python3_3 python3_4" RUBY_TARGETS="ruby22" SANE_BACKENDS="nothing" USERLAND="GNU" VIDEO_CARDS="nvidia" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
USE_PYTHON="3.4 3.3 2.7"
Unset:  CC, CPPFLAGS, CTARGET, CXX, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS

=================================================================
                        Package Settings
=================================================================

app-portage/gentoolkit-0.3.1::gentoo was built with the following:
USE="" ABI_X86="64" PYTHON_TARGETS="python2_7 python3_3 python3_4 -pypy -python3_5"
Comment 2 Nikos Chantziaras 2015-12-16 21:42:32 UTC
Forgot to mention that "host-woods" really has an issue which the new revdep-rebuild did not detect:


$ /usr/bin/host-woods
host-woods: relocation error: host-woods: symbol h_errno, version GLIBC_PRIVATE not defined in file libc.so.6 with link time reference
Comment 3 Brian Dolbec gentoo-dev 2015-12-17 18:33:21 UTC
I hope you haven't fixed it yet.

Please get us a tarball of the affected pkg's files so we can use that to determine how it was missed.

The python version uses a different mechanism which is much faster as you no doubt noticed.
Comment 4 Paul Varner (RETIRED) gentoo-dev 2015-12-17 19:41:07 UTC
This is related to Bug 63643.  The new functionality requested from that bug has not been implemented in the Python version yet.
Comment 5 Nikos Chantziaras 2015-12-17 20:06:34 UTC
(In reply to Brian Dolbec from comment #3)
> I hope you haven't fixed it yet.
> 
> Please get us a tarball of the affected pkg's files so we can use that to
> determine how it was missed.

Sorry. Didn't occur to me to keep the binary around. It's gone by now :-/


> This is related to Bug 63643.  The new functionality requested from that
> bug has not been implemented in the Python version yet.

Not sure what you mean. /usr/bin/host-woods is an executable, not a library?
Comment 6 Paul Varner (RETIRED) gentoo-dev 2015-12-17 20:36:09 UTC
(In reply to Nikos Chantziaras from comment #5)
> Not sure what you mean. /usr/bin/host-woods is an executable, not a library?

There were two changes to revdep-rebuild.sh made from that bug.

1. Detect symbols "not defined" in an executable or library.
2. Add an option to look for "undefined" symbols in a library or executable.

The issue you saw was from the functionality added by the first change.
Comment 7 Todd Goodman 2015-12-18 15:52:56 UTC
I don't know if this is something that should go under this bug or a new bug opened.

Everytime I run the python revdep-rebuild from app-portage/gentoolkit-0.3.1 it rebuilds app-backup/bacula.

Running revdep-rebuild.sh doesn't find anything to rebuild.
Comment 8 Brian Dolbec gentoo-dev 2015-12-18 16:25:00 UTC
The python version primarily uses uses scanelf to gather it's data unlike the bash version.  In some ways it is more accurate, but definitely faster.

There are some applications that generate a false positive for breakage because they have unresolved symbols in the binary that are not set until run time.

Please run scanelf on the affected bacula files.

# scanelf -BF '%F %f %S %n %M'

and post the results.
Comment 9 Todd Goodman 2015-12-18 16:40:33 UTC
(In reply to Brian Dolbec from comment #8)
> The python version primarily uses uses scanelf to gather it's data unlike
> the bash version.  In some ways it is more accurate, but definitely faster.
> 
> There are some applications that generate a false positive for breakage
> because they have unresolved symbols in the binary that are not set until
> run time.
> 
> Please run scanelf on the affected bacula files.
> 
> # scanelf -BF '%F %f %S %n %M'
> 
> and post the results.

# scanelf -BF '%F %f %S %n %M' $(qlist app-backup/bacula)
/usr/lib/libbaccats-sqlite3.so libbaccats-sqlite3.so libbaccats-sqlite3-7.2.0.so libsqlite3.so.0,libstdc++.so.6,libc.so.6,libgcc_s.so.1 ELFCLASS32
/usr/lib/libbaccats-sqlite3-7.2.0.so libbaccats-sqlite3-7.2.0.so libbaccats-sqlite3-7.2.0.so libsqlite3.so.0,libstdc++.so.6,libc.so.6,libgcc_s.so.1 ELFCLASS32
/usr/lib/libbaccats.so libbaccats.so libbaccats-sqlite3-7.2.0.so libsqlite3.so.0
,libstdc++.so.6,libc.so.6,libgcc_s.so.1 ELFCLASS32
/usr/lib/libbaccats-7.2.0.so libbaccats-7.2.0.so libbaccats-sqlite3-7.2.0.so lib
sqlite3.so.0,libstdc++.so.6,libc.so.6,libgcc_s.so.1 ELFCLASS32
/usr/lib/libbacsql.so libbacsql.so libbacsql-7.2.0.so libstdc++.so.6,libc.so.6,l
ibgcc_s.so.1 ELFCLASS32
/usr/lib/libbacsql-7.2.0.so libbacsql-7.2.0.so libbacsql-7.2.0.so libstdc++.so.6
,libc.so.6,libgcc_s.so.1 ELFCLASS32
/usr/lib/bpipe-fd.so bpipe-fd.so bpipe-fd.so libc.so.6 ELFCLASS32
/usr/lib/libbacfind.so libbacfind.so libbacfind-7.2.0.so libbac-7.2.0.so,libpthr
ead.so.0,libstdc++.so.6,libc.so.6,libgcc_s.so.1 ELFCLASS32
/usr/lib/libbacfind-7.2.0.so libbacfind-7.2.0.so libbacfind-7.2.0.so libbac-7.2.
0.so,libpthread.so.0,libstdc++.so.6,libc.so.6,libgcc_s.so.1 ELFCLASS32
/usr/lib/libbaccfg.so libbaccfg.so libbaccfg-7.2.0.so libpthread.so.0,libstdc++.
so.6,libc.so.6,libgcc_s.so.1 ELFCLASS32
/usr/lib/libbaccfg-7.2.0.so libbaccfg-7.2.0.so libbaccfg-7.2.0.so libpthread.so.
0,libstdc++.so.6,libc.so.6,libgcc_s.so.1 ELFCLASS32
/usr/lib/libbac.so libbac.so libbac-7.2.0.so libwrap.so.0,libcap.so.2,libz.so.1,
libssl.so.1.0.0,libcrypto.so.1.0.0,libpthread.so.0,libdl.so.2,libstdc++.so.6,lib
c.so.6,libgcc_s.so.1 ELFCLASS32
/usr/lib/libbac-7.2.0.so libbac-7.2.0.so libbac-7.2.0.so libwrap.so.0,libcap.so.
2,libz.so.1,libssl.so.1.0.0,libcrypto.so.1.0.0,libpthread.so.0,libdl.so.2,libstd
c++.so.6,libc.so.6,libgcc_s.so.1 ELFCLASS32
/usr/sbin/bregex bregex  libbac-7.2.0.so,libc.so.6 ELFCLASS32
/usr/sbin/bwild bwild  libbac-7.2.0.so,libc.so.6 ELFCLASS32
/usr/sbin/dbcheck dbcheck  libbaccats-7.2.0.so,libbacsql-7.2.0.so,libbaccfg-7.2.
0.so,libbac-7.2.0.so,libpthread.so.0,libstdc++.so.6,libgcc_s.so.1,libc.so.6 ELFC
LASS32
/usr/sbin/bsmtp bsmtp  libbac-7.2.0.so,libpthread.so.0,libc.so.6 ELFCLASS32
/usr/sbin/btape btape  libbaccfg-7.2.0.so,libbac-7.2.0.so,libpthread.so.0,libstd
c++.so.6,libgcc_s.so.1,libc.so.6 ELFCLASS32
/usr/sbin/bscan bscan  libbacsql-7.2.0.so,libbaccats-7.2.0.so,libbacfind-7.2.0.s
o,libbaccfg-7.2.0.so,libbac-7.2.0.so,libpthread.so.0,libstdc++.so.6,libgcc_s.so.
1,libc.so.6 ELFCLASS32
/usr/sbin/bcopy bcopy  libbaccfg-7.2.0.so,libbac-7.2.0.so,libpthread.so.0,libstd
c++.so.6,libgcc_s.so.1,libc.so.6 ELFCLASS32
/usr/sbin/bextract bextract  libz.so.1,liblzo2.so.2,libbacfind-7.2.0.so,libbaccf
g-7.2.0.so,libbac-7.2.0.so,libpthread.so.0,libstdc++.so.6,libgcc_s.so.1,libc.so.
6 ELFCLASS32
/usr/sbin/bls bls  libbacfind-7.2.0.so,libbaccfg-7.2.0.so,libbac-7.2.0.so,libpth
read.so.0,libstdc++.so.6,libgcc_s.so.1,libc.so.6 ELFCLASS32
/usr/sbin/bacula-sd bacula-sd  libbaccfg-7.2.0.so,libbac-7.2.0.so,libpthread.so.
0,libstdc++.so.6,libgcc_s.so.1,libc.so.6 ELFCLASS32
/usr/sbin/bacula-dir bacula-dir  libbacfind-7.2.0.so,libbacsql-7.2.0.so,libbacca
ts-7.2.0.so,libbaccfg-7.2.0.so,libbac-7.2.0.so,libpthread.so.0,libstdc++.so.6,li
bgcc_s.so.1,libc.so.6 ELFCLASS32
/usr/sbin/bconsole bconsole  libreadline.so.6,libbaccfg-7.2.0.so,libbac-7.2.0.so
,libpthread.so.0,libstdc++.so.6,libgcc_s.so.1,libc.so.6 ELFCLASS32
/usr/sbin/bacula-fd bacula-fd  libacl.so.1,libz.so.1,libbacfind-7.2.0.so,libbacc
fg-7.2.0.so,libbac-7.2.0.so,libpthread.so.0,liblzo2.so.2,libstdc++.so.6,libgcc_s
.so.1,libc.so.6 ELFCLASS32

It looks like libbaccats-7.2.0.so due to the revdep-rebuild debug output:
    .
    .
    .
* Scanning files
        scan(), scanelf params = ['-BF', '%F %f %S %n %M'], # files: 8984
        scan(), final output length: 6826
        scan_files(); total time to get scanelf data is 407 milliseconds
        scan_files(); total filenames found: 6826 in 639 milliseconds
 * Checking dynamic linking consistency
        analyse(), Searching for 8984 libs, bins within 10802 libraries and link
s
        LibCheck.__init__(), new searchlibs: ['32', '64']
        LibCheck.search(), Checking for broken 32 bit libs
        LibCheck.search(); FOUND: 32bit, libbaccats-7.2.0.so, /usr/sbin/bacula-d
ir
        LibCheck.search(); FOUND: 32bit, libbaccats-7.2.0.so, /usr/sbin/bscan
        LibCheck.search(); FOUND: 32bit, libbaccats-7.2.0.so, /usr/sbin/dbcheck
There are no 64-bit libraries
        LibCheck.search(); Total found: 1 libs, 3 files in 2076 milliseconds
 * Broken files that requires: libbaccats-7.2.0.so (32 bits)
        * /usr/sbin/bacula-dir
        * /usr/sbin/bscan
        * /usr/sbin/dbcheck
        LibCheck.process_results(); total filepaths found: 3 in 0 milliseconds
 * Assign files to packages
        * /usr/sbin/dbcheck -> app-backup/bacula-7.2.0
        * /usr/sbin/bscan -> app-backup/bacula-7.2.0
        * /usr/sbin/bacula-dir -> app-backup/bacula-7.2.0
        assign_packages(); assigned 1 packages, 0 orphans in 1764 milliseconds
Comment 10 Brian Dolbec gentoo-dev 2015-12-18 18:22:30 UTC
I just emerged bacula (new with some deps), and revdep-rebuild is detecting it as broken, same output as you.  So, it looks like this is a false positive.

Hmm, adding libbaccats-7.2.0.so to LD_LIBRARY_MASK in /etc/revdep-build/  isn't stopping it from detecting it as positive for rebuild.
Comment 11 bwcknr 2015-12-20 08:18:14 UTC
Similar problem over here with libreoffice.

libjawt.so is defined as LD_LIBRARY_MASK but disrespected by revdep-rebuild run.

~ # grep -r libjawt.so /etc/revdep-rebuild
/etc/revdep-rebuild/60-java:LD_LIBRARY_MASK="libjvm.so libjawt.so"

~ # revdep-rebuild -dp
 * This is the new python coded version
 * Please report any bugs found using it.
 * The original revdep-rebuild script is installed as revdep-rebuild.sh
 * Please files bugs at: https://bugs.gentoo.org/
	main(), _libs_to_check = set()
 * Collecting system binaries and libraries
	analyse(), bin directories:
		/bin
		/lib
		/lib32
		/lib64
		/opt/bin
		/sbin
		/usr/bin
		/usr/lib
		/usr/lib32
		/usr/lib64
		/usr/libexec
		/usr/sbin
		/usr/x86_64-pc-linux-gnu/gcc-bin/5.3.0
	analyse(), lib directories:
		/bin
		/lib
		/lib32
		/lib64
		/sbin
		/usr/bin
		/usr/lib
		/usr/lib/gcc/x86_64-pc-linux-gnu/5.3.0
		/usr/lib/gcc/x86_64-pc-linux-gnu/5.3.0/32
		/usr/lib/postgresql
		/usr/lib32
		/usr/lib32/OpenCL/vendors/nvidia
		/usr/lib32/opengl/nvidia/lib
		/usr/lib32/qt4
		/usr/lib64
		/usr/lib64/OpenCL/vendors/nvidia
		/usr/lib64/opengl/nvidia/lib
		/usr/lib64/postgresql
		/usr/lib64/postgresql-9.4/lib64/
		/usr/lib64/qt4
		/usr/libexec
		/usr/local/lib
		/usr/local/lib32
		/usr/local/lib64
		/usr/sbin
	analyse(), masked directories:
		/lib/modules
		/lib32/modules
		/lib64/modules
		/opt/oracle-jdk-bin-1.8.0.66
	analyse(), masked files:
		
		libjava.so
		libjawt.so
		libjvm.so
		libodbc.so
		libodbcinst.so
	time to complete task: 9 milliseconds
 * Collecting dynamic linking informations
	Exception collecting libraries: [Errno 2] No such file or directory: '/usr/local/lib32'
	time to complete task: 7651 milliseconds
	analyse(), Found 17270 libraries (+4646 symlinks) and 16283 binaries
 * Scanning files
	scan(), scanelf params = ['-BF', '%F %f %S %n %M'], # files: 17587
	scan(), final output length: 13067
	scan_files(); total time to get scanelf data is 1569 milliseconds
	scan_files(); total filenames found: 8492 in 1048 milliseconds
 * Checking dynamic linking consistency
	analyse(), Searching for 17587 libs, bins within 21916 libraries and links
	LibCheck.__init__(), new searchlibs: ['32', '64']
	LibCheck.search(), Checking for broken 32 bit libs
	LibCheck.search(), Checking for broken 64 bit libs
	LibCheck.search(); FOUND: 64bit, libjawt.so, /usr/lib64/libreoffice/program/libofficebean.so
	LibCheck.search(); Total found: 1 libs, 1 files in 1309 milliseconds
 * Broken files that requires: libjawt.so (64 bits)
	* /usr/lib64/libreoffice/program/libofficebean.so
	LibCheck.process_results(); total filepaths found: 1 in 0 milliseconds
 * Assign files to packages
	* /usr/lib64/libreoffice/program/libofficebean.so -> app-office/libreoffice-5.0.4.2
	assign_packages(); assigned 1 packages, 0 orphans in 1472 milliseconds

emerge  --pretend --verbose --oneshot --complete-graph=y app-office/libreoffice:0

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild   R    ] app-office/libreoffice-5.0.4.2::gentoo  USE="bluetooth branding cups dbus eds gnome gstreamer gtk java (-aqua) -coinmp -collada -debug (-firebird) -gltf -gtk3 -jemalloc -kde -libressl -mysql -odk -postgres (-telepathy) {-test} -vlc" LIBREOFFICE_EXTENSIONS="nlpsolver -scripting-beanshell -scripting-javascript -wiki-publisher" PYTHON_SINGLE_TARGET="python2_7 -python3_4 -python3_5" PYTHON_TARGETS="python2_7 python3_4 -python3_5" 0 KiB

Total: 1 package (1 reinstall), Size of downloads: 0 KiB
	rebuild(); emerge call for 1 ebuilds took: 25.509 seconds
rebuild return code = 0
Comment 12 Alex Busenius 2016-01-06 15:36:49 UTC
Created attachment 422138 [details]
broken host-woods.gz

In case you need the broken /usr/bin/host-woods that is found by revdep-rebuild.sh, but not by revdep-rebuild (symbol h_errno, version GLIBC_PRIVATE not defined in file libc.so.6 with link time reference)
Comment 13 James Le Cuirot gentoo-dev 2016-01-13 22:12:56 UTC
I'm not sure if there are multiple issues being reported here but I think the LD_LIBRARY_MASK issue is due to the masked_files variable being unused after calling parse_revdep_config() at the bottom of collect.py. Unfortunately I'm not familiar with the code enough to fix it.
Comment 14 James Le Cuirot gentoo-dev 2016-01-13 22:14:53 UTC
*** Bug 571242 has been marked as a duplicate of this bug. ***
Comment 15 James Le Cuirot gentoo-dev 2016-01-26 21:27:27 UTC
*** Bug 573054 has been marked as a duplicate of this bug. ***
Comment 16 Thomas Deutschmann gentoo-dev 2016-03-02 01:34:37 UTC
Created attachment 427176 [details]
revdep-rebuild vs revdep-rebuild.sh

With the recent dev-libs/openssl-1.0.2g bump, revdep-rebuild failed to identify just one package which must be rebuild.

revdep-rebuild.sh founds multiple packages, see the attachment.
Comment 17 Paul Varner (RETIRED) gentoo-dev 2016-03-02 23:14:44 UTC
(In reply to Thomas D. from comment #16)
> 
> With the recent dev-libs/openssl-1.0.2g bump, revdep-rebuild failed to
> identify just one package which must be rebuild.

The issue is that the python version does not use basic regular expressions as documented in the man page. The python version use full or partial library names

The following command will do what you want:

revdep-rebuild -i -L 'libssl.so' -- --exclude=openssl
Comment 18 Paul Osmialowski 2016-12-20 12:20:30 UTC
I'm sorry for lack of the details, but I'm extremely busy today nevertheless, I don't want this glitch to be left unnoticed:
revdep-debuild didn't find this after today's updates:

broken /usr/games/bin/atanks (symbol _ZNSt6chrono12steady_clock3nowEv, version GLIBCXX_3.4.17 not defined in file libstdc++.so.6 with link time reference)

this was found by consecutive run of revdep-rebuild.sh executed 'just in case'.